"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const logger_1 = __importDefault(require("../../../../shared/logger"));
const child_process_1 = require("child_process");
exports.runCommand = (options) => {
    return new Promise(function (fulfill, reject) {
        try {
            logger_1.default.info(`Clone project in directory: ${options.path}`);
            logger_1.default.debug(`Running ${options.command}...`);
            const task = child_process_1.spawn(`cd ${options.path} && ${options.command}`, [], {
                shell: true
            });
            // Método para imprimir el log normal
            task.stdout.on("data", data => {
                logger_1.default.info(data.toString());
                if (data.includes("Step success finished")) {
                    task.kill("SIGINT");
                    fulfill(true);
                }
                if (data.includes("Successfully unlinked")) {
                    task.kill("SIGINT");
                    fulfill(true);
                }
            });
            // Método para imprimir el log de error
            task.stderr.on("data", function (data) {
                logger_1.default.info("Error: " + data);
                // Validación en caso de error
                if (data.includes("App build failed with message")) {
                    reject(false);
                    process.exit();
                }
                if (data.includes("Error unlinking")) {
                    task.kill("SIGINT");
                    fulfill(true);
                }
            });
        }
        catch (error) {
            reject(error);
        }
    });
};
