"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const aws_commands_1 = require("./aws-commands");
exports.executeCommands = (options) => __awaiter(void 0, void 0, void 0, function* () {
    let index = options.position;
    // Recorro la lista de projectos
    if (index < options.projectList.length) {
        // Obtengo el path del projecto, buscando en la lista de manifests
        let optionsCommand = {
            path: options.path,
            credentials: options.credentials,
            project: options.projectList[index],
            branch: options.branch
        };
        let succes = yield aws_commands_1.cloneProject(optionsCommand);
        if (succes) {
            index++;
            let optionsExec = {
                path: options.path,
                credentials: options.credentials,
                projectList: options.projectList,
                branch: options.branch,
                position: index
            };
            return exports.executeCommands(optionsExec);
        }
        else {
            return false;
        }
    }
    else {
        return true;
    }
});
module.exports = {
    executeCommands: exports.executeCommands
};
