"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Método empleado para realizar el filtro de la lista de proyectos obtenidos
 * @param projectsList
 * @param term
 */
exports.filterProjects = (projectsList, term) => __awaiter(void 0, void 0, void 0, function* () {
    return yield projectsList.repositories.filter((item) => {
        return Object.keys(item).find(element => {
            if (typeof item[element] === "string" ||
                item[element] instanceof String) {
                // Busco los projectos de acuerdo al termino ingresado por el usuario
                let isSelected = item[element].toUpperCase().indexOf(term.toUpperCase()) !== -1;
                return isSelected;
            }
            else {
                return false;
            }
        });
    });
});
