"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const logger_1 = __importDefault(require("../../../../shared/logger"));
const inquirer_1 = __importDefault(require("inquirer"));
/**
 *  Método para obtener el criterio de busqueda a emplear para filtrar los projectos
 */
exports.getCriteriaOfSearch = () => __awaiter(void 0, void 0, void 0, function* () {
    // 1.  Pregunto por el indicativo a emplear para filtrar los projectos
    const questions = [
        {
            type: "input",
            name: "criteria",
            message: "Enter criteria of search or press enter to list all projects",
            validate: (criteria) => (criteria == undefined ? false : true)
        }
    ];
    let response = yield inquirer_1.default.prompt(questions);
    if (response.criteria) {
        return response.criteria;
    }
    else {
        if (response.criteria != undefined) {
            logger_1.default.debug("No criteria enter, list all projects");
            return "all";
        }
        return "none";
    }
});
