"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const logger_1 = __importDefault(require("../../../../shared/logger"));
const inquirer_1 = __importDefault(require("inquirer"));
const chalk_1 = __importDefault(require("chalk"));
// Método que busca una dependencia e la lista de dependencias filtradas por el usuario
exports.findDependency = (projectList) => __awaiter(void 0, void 0, void 0, function* () {
    if (projectList.length) {
        let filderDependencies = yield choiseDependencies(projectList);
        if (filderDependencies.projects) {
            projectList = yield projectList.filter((item) => {
                let isFind = filderDependencies.projects.find((filter) => {
                    if (item.value == filter) {
                        return true;
                    }
                    else {
                        return false;
                    }
                });
                return isFind;
            });
            logger_1.default.info(`Proyects to clone: ${chalk_1.default.redBright(`${projectList.length}`)}`);
            return projectList;
        }
        else {
            return [];
        }
    }
    else {
        logger_1.default.debug('No projects found with the criteria specific');
        return [];
    }
});
const choiseDependencies = (projectList) => __awaiter(void 0, void 0, void 0, function* () {
    let dependencies = [
        new inquirer_1.default.Separator(`${chalk_1.default.whiteBright('Select the projects to clone')} \n`),
        ...projectList
    ];
    const promptCommands = yield inquirer_1.default.prompt([
        {
            type: 'checkbox',
            message: `${chalk_1.default.redBright('Pick The Project to clone')}`,
            name: 'projects',
            choices: dependencies
        }
    ]);
    return promptCommands;
});
