"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const shared_1 = require("../../shared");
const conf_1 = require("../../conf");
const chalk_1 = __importDefault(require("chalk"));
exports.default = () => __awaiter(void 0, void 0, void 0, function* () {
    try {
        // Get the current credentials
        let credential = conf_1.getAwsAccount();
        if (credential) {
            shared_1.logger.info(`current credentials for aws: user ${chalk_1.default.redBright(credential.username)} password ${chalk_1.default.redBright(credential.pwd)}`);
        }
        else {
            shared_1.logger.debug("No have aws credentials, save your aws credentials for clone projects");
        }
    }
    catch (e) {
        shared_1.logger.debug(e);
    }
});
