"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const inquirer_1 = __importDefault(require("inquirer"));
const conf_1 = require("../../conf");
const shared_1 = require("./../../shared");
const set_credentials_1 = require("./set-credentials");
const emptyUser = {
    username: "",
    pwd: ""
};
exports.PrompCredentials = () => __awaiter(void 0, void 0, void 0, function* () {
    try {
        // Get the current credentials
        let credential = conf_1.getAwsAccount();
        if (credential) {
            return credential;
        }
        else {
            shared_1.logger.debug("No have aws credentials, save your aws credentials for clone projects");
            return yield exports.requireCredentials();
        }
    }
    catch (e) {
        shared_1.logger.debug(e);
        return emptyUser;
    }
});
exports.requireCredentials = () => __awaiter(void 0, void 0, void 0, function* () {
    shared_1.logger.info("Enter credentials for AWS");
    // Get AWS CodeCommit Credential
    const credentials = yield promptCredentials();
    if (credentials.username !== "") {
        let isSave = yield set_credentials_1.saveCredentials(credentials);
        if (isSave) {
            return credentials;
        }
        else {
            return emptyUser;
        }
    }
    else {
        return emptyUser;
    }
});
/**
 *  Metodo empleado para realizar la solicitud de las credenciales al usuario
 */
const promptCredentials = () => __awaiter(void 0, void 0, void 0, function* () {
    const questions = [
        {
            type: "input",
            name: "username",
            message: "What is your AWS CodeCommit username?"
        },
        {
            type: "input",
            name: "pwd",
            message: "What is your password"
        }
    ];
    let response = yield inquirer_1.default.prompt(questions);
    if (response) {
        return response;
    }
    else {
        return emptyUser;
    }
});
