"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
let currentOptions;
// Retorno la cadena de string con los diferentes metodos que se quieren escuchar del trigger
const getUpdateReference = () => {
    let updateReference = "";
    currentOptions.updateReference.map((item) => (updateReference += `"${item}"${currentOptions.updateReference.length > 1 ? "," : ""}`));
    return updateReference;
};
const createCodeCommitConfig = (branchInfo) => {
    return `{
    "destinationArn": "${currentOptions.destinationArn}",
    "events": [
        ${getUpdateReference()}
    ],
    "branches": [
        "${branchInfo.name}"
    ],
    "name": "${currentOptions.codeCommitProject.replace(".", "-")}-${branchInfo.name}-${branchInfo.customData.vendor}-deploy",
    "customData": "${escape(branchInfo.customData)}"
}`;
};
const getCodeBuildProjects = () => {
    let codeCommit = [];
    currentOptions.branches.map((branchInfo) => codeCommit.push(createCodeCommitConfig(branchInfo)));
    return codeCommit;
};
exports.getTemplateContent = (options) => {
    currentOptions = options;
    return `{
    "repositoryName": "${options.codeCommitProject}",
    "triggers": [
    ${getCodeBuildProjects()}
]
}`;
};
const escape = (obj) => {
    var escapedValue = JSON.stringify(obj).replace(/"/g, '\\"');
    return escapedValue;
};
