"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const inquirer_1 = __importDefault(require("inquirer"));
const shared_1 = require("./../../../shared");
function default_1() {
    return __awaiter(this, void 0, void 0, function* () {
        shared_1.logger.info("Enter the options to create the workspace config");
        let questions = [
            {
                type: "input",
                name: "develop",
                message: "develop workspace name",
                default: "develop",
                validate: function (value) {
                    let valid = value.length >= 3;
                    return (valid ||
                        `Invalid workspace name: ${value}. Must be at least 3 characters, only lowercase alphanumeric, single dashes (-) or underlines (_)`);
                }
            },
            {
                type: "input",
                name: "qa",
                message: "qa workspace name",
                default: "qa",
                validate: function (value) {
                    let valid = value.length >= 2;
                    return (valid ||
                        `Invalid workspace name: ${value}. Must be at least 2 characters, only lowercase alphanumeric, single dashes (-) or underlines (_)`);
                }
            },
            {
                type: "input",
                name: "quantity",
                message: "number of workspace for qa",
                validate: function (value) {
                    let valid = !isNaN(parseFloat(value));
                    if (!(parseFloat(value) > 0)) {
                        return "Please enter a number different of 0";
                    }
                    else {
                        return valid || "Please enter a number";
                    }
                },
                filter: Number
            }
        ];
        // Cuando obtenga la respuesta de la validacion de los campo, paso a realizar una confirmación de los comandos a ejecutar
        inquirer_1.default.prompt(questions).then((answers) => {
            let question = answers;
            confirmCreation(question);
        });
    });
}
exports.default = default_1;
const confirmCreation = (question) => {
    let questions = [
        {
            type: "confirm",
            name: "confirm",
            message: `I Create one workspace call ${question.develop} and ${question.quantity} workspaces called ${question.qa}, Use this configuration?`,
            default: false
        }
    ];
    inquirer_1.default.prompt(questions).then((answers) => __awaiter(void 0, void 0, void 0, function* () {
        let result = answers;
        if (result.confirm) {
            let createDevelop = `${shared_1.configuration.workspace_create} ${question.develop} `;
            let createQa = "";
            let command = "";
            if (question.quantity > 1) {
                for (let index = 1; index <= question.quantity; index++) {
                    createQa += `${shared_1.configuration.workspace_create} ${question.qa +
                        index} && `;
                }
            }
            else {
                createQa = `${shared_1.configuration.workspace_create} ${question.qa +
                    question.quantity} && `;
            }
            Promise.all(createQa).then(() => {
                command = createQa + createDevelop;
                shared_1.childProcessRunCommand(command);
            });
        }
        else {
            return false;
        }
    }));
};
