"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_extra_1 = require("fs-extra");
const pipe_streams_to_promise_1 = __importDefault(require("pipe-streams-to-promise"));
const request_1 = __importDefault(require("request"));
const unzip_stream_1 = __importDefault(require("unzip-stream"));
const shared_1 = require("../../../shared");
const urlForRepo = (repo) => `https://github.com/${shared_1.configuration.github_account}/${repo}/archive/master.zip`;
const fetchAndUnzip = (url, path) => __awaiter(void 0, void 0, void 0, function* () { return pipe_streams_to_promise_1.default([request_1.default(url), unzip_stream_1.default.Extract({ path })]); });
exports.clone = (repo) => __awaiter(void 0, void 0, void 0, function* () {
    const cwd = process.cwd();
    const url = urlForRepo(repo);
    const cloned = `${cwd}/${repo}-master`;
    shared_1.logger.debug(url);
    yield fs_extra_1.emptyDir(cwd);
    yield fetchAndUnzip(url, cwd);
    yield fs_extra_1.copy(cloned, cwd);
    yield fs_extra_1.remove(cloned);
});
exports.download = (repo) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        const cwd = process.cwd();
        const url = urlForRepo(repo);
        const cloned = `${cwd}/${repo}-master`;
        yield fetchAndUnzip(url, cwd);
        yield fs_extra_1.copy(cloned, cwd);
        yield fs_extra_1.remove(cloned);
        return true;
    }
    catch (error) {
        shared_1.logger.debug(`Error on clone project ${error}`);
        return false;
    }
});
