"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const inquirer = __importStar(require("inquirer"));
const ramda_1 = require("ramda");
const shared_1 = require("./../../../shared");
const git = __importStar(require("./git"));
const templates = {
    "hello react typescript": "hello-react-ts",
    "get started with react + redux + sagas": "react-with-redux",
    "graphql get started": "graphql-getstarted"
};
const promptTemplates = () => __awaiter(void 0, void 0, void 0, function* () {
    const cancel = "Cancel";
    const chosen = ramda_1.prop("service", yield inquirer.prompt({
        name: "service",
        message: shared_1.configuration.messages.gitInitProject,
        type: "list",
        choices: [...ramda_1.keys(templates), cancel]
    }));
    if (chosen === cancel) {
        shared_1.logger.info(shared_1.configuration.messages.gitInitClose);
        return process.exit();
    }
    return chosen;
});
const promptContinue = () => __awaiter(void 0, void 0, void 0, function* () {
    const promt = yield inquirer.prompt({
        name: "proceed",
        message: `You are about to remove all files in ${process.cwd()}. Do you want to continue?`,
        type: "confirm"
    });
    const proceed = ramda_1.prop("proceed", promt);
    if (!proceed) {
        shared_1.logger.info(shared_1.configuration.messages.gitInitClose);
        process.exit();
    }
});
exports.default = () => __awaiter(void 0, void 0, void 0, function* () {
    shared_1.logger.debug("Prompting for app info");
    shared_1.logger.info(shared_1.configuration.messages.gitInitHellow);
    try {
        const repo = templates[yield promptTemplates()];
        console.log(repo);
        yield promptContinue();
        shared_1.logger.info(`Cloning https://${shared_1.configuration.github_account}s/${repo}.git`);
        git.clone(repo);
    }
    catch (err) {
        shared_1.logger.error(err.message);
        err.printStackTrace();
    }
});
