"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const shared_1 = require("../../../shared");
exports.default = (location, command) => __awaiter(void 0, void 0, void 0, function* () {
    const directory = process.cwd() + "/";
    shared_1.logger.info(directory);
    shared_1.logger.info(location, command);
    // First get the projects list to use
    const projectsInCurrentDirectory = yield shared_1.readDirectoryByFiles(directory, ["manifest.json"], "Pick the projects to use", "Select the projects");
    // 2. Get manifest content
    let manifest = yield findProjectContent(projectsInCurrentDirectory);
    if (!manifest.length) {
        shared_1.logger.error("No manifest content");
        process.exit(1);
    }
    yield manifest.map((item) => __awaiter(void 0, void 0, void 0, function* () {
        const name = `${item.vendor}.${item.name}`;
        const commandInterpolation = command.replace("${name}", name);
        const finalCommand = `cd ${item.path} && ${location} && ${commandInterpolation}`;
        yield shared_1.runOnlyCommand(finalCommand);
    }));
    //  Make the interpolation in the command passed
});
const findProjectContent = (files) => __awaiter(void 0, void 0, void 0, function* () {
    // si hay directorios, paso a buscar el archivo manifest.json y obtener su contenido
    const manifests = yield shared_1.getManifestsContent(files);
    if (manifests.length) {
        return manifests;
    }
    else {
        return [];
    }
});
