"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const shared_1 = require("./../../../../shared");
const fs_1 = require("fs");
const pkg = __importStar(require("./../../../../../package.json"));
exports.overWriteChangeLogFile = (directory, changelogInfo) => __awaiter(void 0, void 0, void 0, function* () {
    shared_1.logger.info("OverWrite Changelog", directory);
    // 1. Obtengo el cotenido del archivo Changelog
    let changeLogData = yield shared_1.readFileInDirectory(`${directory}/CHANGELOG.md`, false);
    let prefixReplace = "";
    let changelogContent = "";
    if (!changeLogData) {
        prefixReplace = /^/;
    }
    else {
        prefixReplace = "## [Unreleased]";
        changelogContent = changeLogData;
    }
    // Reemplazo el contenido del changelog agregando las dependencias modificadas y la version asignada junto a la fecha y la version de la cli que realizo el cambio.
    let replaceInfo = changelogContent.replace(prefixReplace, `## [Unreleased]
    
## [${changelogInfo.version}] - ${getCurrentDate()}
  
### Changed
  
- Update in the following dependencies with the version of exito: ${pkg.version}
${"``` json"} 
  ${JSON.stringify(changelogInfo.dependencies, null, 4)}
${"```"}`);
    yield writeFile(`${directory}/CHANGELOG.md`, replaceInfo);
});
function getCurrentDate() {
    return new Date()
        .toJSON()
        .slice(0, 10)
        .replace(/-/g, "-");
}
// Método para escribir el archivo manifest.json
const writeFile = (path, string) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        yield fs_1.writeFileSync(path, string);
        shared_1.logger.debug(`Changelog file update in the directory ${path}`);
    }
    catch (error) {
        shared_1.logger.error(error);
    }
});
