"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const shared_1 = require("../../../shared");
const run_only_command_1 = require("../../../shared/util/run-only-command");
exports.runTriggers = (commandToRun) => __awaiter(void 0, void 0, void 0, function* () {
    const directory = process.cwd() + "/";
    shared_1.logger.info(directory);
    // 1. Leo el directorio actual y permito seleccionar todos los proyectos deseados
    const currentDirectory = yield shared_1.readDirectoryByExtension(directory, [".json"], "Pick the file to use", "Select the .json file to use");
    const projectsList = shared_1.getProjectNames(currentDirectory);
    executeTriggerUpdate(projectsList, commandToRun);
});
const executeTriggerUpdate = (projectsList, commandToRun) => {
    try {
        projectsList.map((name) => __awaiter(void 0, void 0, void 0, function* () {
            //a function that returns a promise
            const command = `aws codecommit ${commandToRun} --repository-name ${name} --cli-input-json file://${name}.json`;
            yield run_only_command_1.runOnlyCommand(command);
            shared_1.logger.debug("Finish Running: " + name);
        }));
    }
    catch (error) {
        shared_1.logger.error("Error on update trigger: " + error);
    }
};
