"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const Configstore = require("configstore");
const path_1 = require("path");
const os_1 = require("os");
const fs = __importStar(require("fs"));
const shared_1 = require("../../../../../shared");
exports.saveVtexConfig = (configuration, path) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        // const conf = new Configstore("vtex");
        // await conf.clear();
        // conf.all = configuration;
        // logger.info("vtex json configstore save successfully");
        //file tokens vtex
        const tokenCacheStore = new Configstore("vtex-tokens");
        // const tokenCacheStore = new Configstore("", null, {
        //   configPath: join(VTEX_SESSION_FOLDER, "tokens.json"),
        // });
        const confToken = {};
        confToken[configuration.account] = configuration.token;
        yield tokenCacheStore.clear();
        tokenCacheStore.all = confToken;
        //File workspace vtex
        const workspaceMetadataStore = new Configstore("vtex-workspace");
        // const workspaceMetadataStore = new Configstore("", null, {
        //   configPath: join(VTEX_SESSION_FOLDER, "workspace.json"),
        // });
        const confWorkspace = {
            currentWorkspace: configuration.workspace,
        };
        yield workspaceMetadataStore.clear();
        workspaceMetadataStore.all = confWorkspace;
        //File session vtex
        const sessionStore = new Configstore("vtex-session");
        // const sessionStore = new Configstore("", null, {
        //   configPath: join(VTEX_SESSION_FOLDER, "session.json"),
        // });
        const confSession = {
            account: configuration.account,
            login: configuration.login,
            token: configuration.token,
        };
        yield sessionStore.clear();
        sessionStore.all = confSession;
        shared_1.logger.info("vtex json sessions save successfully");
        const VTEX_SESSION_FOLDER = path
            ? path_1.join(path, ".vtex", "session")
            : path_1.join(os_1.homedir(), ".vtex", "session");
        shared_1.logger.info("vtex json folder: ", VTEX_SESSION_FOLDER);
        if (!fs.existsSync(VTEX_SESSION_FOLDER)) {
            fs.mkdirSync(VTEX_SESSION_FOLDER, {
                recursive: true
            });
        }
        fs.rename(path_1.join(os_1.homedir(), ".config", "configstore", "vtex-tokens.json"), path_1.join(VTEX_SESSION_FOLDER, "tokens.json"), function (err) {
            if (err)
                throw err;
        });
        fs.rename(path_1.join(os_1.homedir(), ".config", "configstore", "vtex-workspace.json"), path_1.join(VTEX_SESSION_FOLDER, "workspace.json"), function (err) {
            if (err)
                throw err;
        });
        fs.rename(path_1.join(os_1.homedir(), ".config", "configstore", "vtex-session.json"), path_1.join(VTEX_SESSION_FOLDER, "session.json"), function (err) {
            if (err)
                throw err;
        });
        shared_1.logger.info("vtex json move successfully");
    }
    catch (error) {
        shared_1.logger.error("Error on save the vtex file");
        process.exit(1);
    }
});
