"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const shared_1 = require("./../../../../shared");
const child_process_publish_1 = require("./util/child-process-publish");
const directory = process.cwd() + "/";
let commandToUse = "";
function default_1(command) {
    return __awaiter(this, void 0, void 0, function* () {
        // Capturo el flag para saber si empleo la ultima versión siempre o no.
        const SCAPECOMMAND = "--scape";
        const scapeCommand = process.argv.indexOf(SCAPECOMMAND) >= 0;
        commandToUse = command;
        if (scapeCommand) {
            commandToUse = command.replace(/\@S+/g, " ");
            commandToUse = commandToUse.replace(/\@AND+/g, "&&");
        }
        shared_1.logger.debug(`Command to run: ${commandToUse}`);
        shared_1.logger.info("Loading publish component process");
        searchProjectCurrentDirectory();
    });
}
exports.default = default_1;
const publishComponent = (manifest) => {
    // Uso el workspace master y realizo la publicación
    let command_create_workspace = `cd ${manifest.path} && ${commandToUse}`;
    child_process_publish_1.childProcessRunCommandPublish(command_create_workspace);
};
// Método que se encarga de buscar un proyecto en el directorio actual
const searchProjectCurrentDirectory = () => __awaiter(void 0, void 0, void 0, function* () {
    shared_1.logger.debug("Use the current location for search one project");
    let response = yield findProjectContent([directory]);
    // si no se encontraron projectos en el directorio actual, paso a buscar en los sub directorios.
    if (!response) {
        // obtengo todos los nombres de las carpetas dentro del directorio indicado
        let files = yield shared_1.getDirectories(directory);
        if (files.length) {
            let subFiles = yield findProjectContent(files);
            if (!subFiles) {
                process.exit(1);
            }
            else {
                shared_1.logger.info(`Project found in the sub location`);
            }
        }
        else {
            shared_1.logger.warn(`No projects found in ${directory}`);
            process.exit(1);
        }
    }
});
const findProjectContent = (files) => __awaiter(void 0, void 0, void 0, function* () {
    // si hay directorios, paso a buscar el archivo manifest.json y obtener su contenido
    const manifests = yield shared_1.getManifestsContent(files);
    if (manifests.length) {
        publishComponent(manifests[0]);
        return true;
    }
    else {
        return false;
    }
});
