"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const logger_1 = __importDefault(require("../../../../../shared/logger"));
const child_process_1 = require("child_process");
exports.childProcessRunCommandPublish = function (command) {
    const task = child_process_1.spawn(`${command}`, [], {
        shell: true
    });
    // Método para imprimir el log normal
    task.stdout.on('data', (data) => {
        logger_1.default.info(data.toString());
        validateBuild(data);
    });
    // Método para imprimir el log de error
    task.stderr.on('data', function (data) {
        logger_1.default.info(data.toString());
        validateBuild(data);
    });
};
const validateBuild = (data) => {
    if (data.toString().includes('Failed to publish')) {
        logger_1.default.error('exito cli error on publish component');
        process.exit(1);
    }
    else if (data.toString().includes('504 Gateway Time-out')) {
        logger_1.default.error('exito cli error on publish component');
        process.exit(1);
    }
    else if (data.toString().includes('Request failed with status code 404')) {
        logger_1.default.error('exito cli error on publish component');
        process.exit(1);
    }
    else if (data.toString().includes('An error happened while building')) {
        logger_1.default.error('exito cli error on publish component');
        process.exit(1);
    }
};
