"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require('fs');
const shared_1 = require("../../../../shared");
// Metodo que trae el contenido de un directorio indicado
exports.getJestConfigContent = (dir) => __awaiter(void 0, void 0, void 0, function* () {
    let jest = null;
    try {
        if (fs.existsSync(dir)) {
            console.log(dir);
            // Do something
            let result = yield fs.readFileSync(dir, 'utf8');
            if (result) {
                let newResult = result.replace('= {', `= {
            coverageThreshold: {
            "global": {
              "branches": 50,
              "functions": 50,
              "lines": 50
            }
        },`);
                jest = newResult;
                return jest;
            }
        }
        else {
            shared_1.logger.debug(`jest.config.js not found in ${dir}`);
            process.exit(1);
        }
    }
    catch (error) {
        shared_1.logger.debug(`error on read the jest.config.js file in ${dir} check the content`);
        process.exit(1);
    }
});
// Metodo que trae el contenido de un directorio indicado
exports.getSonarQubeContent = (dir) => __awaiter(void 0, void 0, void 0, function* () {
    let jest = null;
    try {
        if (fs.existsSync(dir)) {
            // Do something
            let result = yield fs.readFileSync(dir, 'utf8');
            if (result) {
                jest = result += `sonar.host.url=http://18.213.20.207/
sonar.login=c234975f7deabc7e40e6dcc4af2e3cfd9168a96e`;
                return jest;
            }
        }
        else {
            shared_1.logger.debug(`sonar-project.properties not found in ${dir}`);
            process.exit(1);
        }
    }
    catch (error) {
        shared_1.logger.debug(`error on read the sonar-project.properties file in ${dir} check the content`);
        process.exit(1);
    }
});
