"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const csv_file_validator_1 = __importDefault(require("csv-file-validator"));
const logger_1 = __importDefault(require("../../../shared/logger"));
const login_vtex_1 = __importDefault(require("../commands/login/login-vtex"));
const run_multiple_command_1 = require("../../../shared/util/run-multiple-command");
const path = __importStar(require("path"));
const directory = process.cwd();
function default_1(file, account, email, token) {
    return __awaiter(this, void 0, void 0, function* () {
        //Searching in the current directory if the specified file exists
        const routeFile = path.resolve(directory, file);
        let responseFile = fs_1.default.existsSync(routeFile);
        logger_1.default.debug("Searching in the current directory if the specified file exists");
        if (responseFile) {
            logger_1.default.debug(routeFile);
            logger_1.default.debug("Validating file");
            //Cargo el archivo y valido que contenga al final la linea vacia
            const file = fs_1.default.readFileSync(routeFile, "utf8");
            const arrayFile = file.split("\n");
            if (arrayFile[arrayFile.length - 1] != "") {
                logger_1.default.error("The file must end with an empty line");
                process.exit(1);
            }
            else {
                //Se elimina la ultima fila y se valida el csv con la libreria csv-file-validator
                arrayFile.pop();
                const newFile = arrayFile.join("\n");
                const config = {
                    headers: [
                        {
                            name: "from",
                            inputName: "from",
                            required: true
                        },
                        {
                            name: "to",
                            inputName: "to",
                            required: true
                        },
                        {
                            name: "type",
                            inputName: "type",
                            required: true
                        },
                        {
                            name: "endDate",
                            inputName: "endDate",
                            required: false
                        }
                    ]
                };
                csv_file_validator_1.default(newFile, config)
                    .then((csvData) => __awaiter(this, void 0, void 0, function* () {
                    //Si la validacion del archivo es existosa se procede con el flujo de importacion a vtex
                    if (csvData.inValidMessages.length == 0) {
                        if (csvData.data.length == 0) {
                            logger_1.default.error("The file is not formatted correctly");
                            process.exit(1);
                        }
                        else {
                            logger_1.default.debug("Login vtex");
                            yield login_vtex_1.default(account, "master", email, token);
                            //exito vtex importRedirects prueba.csv exito andflorezr@grupo-exito.com AzYlVbP6fs98Jna6Sml6KFkgVHczT3L2dyWsDFxw --verbose
                            yield run_multiple_command_1.runMultipleCommand("vtex whoami");
                            //await runMultipleCommand(`vtex redirects import ${routeFile} --verbose`);
                        }
                    }
                    else {
                        csvData.inValidMessages.forEach((element) => {
                            logger_1.default.error(element);
                        });
                        process.exit(1);
                    }
                }))
                    .catch((err) => {
                    console.log("error: " + err);
                });
            }
        }
        else {
            logger_1.default.error("The file does not exists :(");
            process.exit(1);
        }
    });
}
exports.default = default_1;
