"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const winston_1 = __importDefault(require("winston"));
const moment_1 = __importDefault(require("moment"));
const chalk_1 = __importDefault(require("chalk"));
const path_1 = __importDefault(require("path"));
// create formatter for dates used as timestamps  HH:mm:ss.SSS
const tsFormat = () => chalk_1.default.whiteBright(moment_1.default()
    .format("HH:mm")
    .trim());
// define a logger with 2 transports - console and a file
exports.logger = new winston_1.default.Logger({
    transports: [
        // colorize the output to the console
        new winston_1.default.transports.Console({
            timestamp: tsFormat,
            colorize: true
        }),
        new winston_1.default.transports.File({
            filename: path_1.default.join(__dirname, "../../ttracker.log"),
            timestamp: tsFormat,
            json: true // makes log format just like console output
        })
    ]
});
// set logging level one of { error: 0, warn: 1, info: 2, verbose: 3, debug: 4, silly: 5 }
const VERBOSE = "--verbose";
const isVerbose = process.argv.indexOf(VERBOSE) >= 0;
if (isVerbose) {
    exports.logger.level = "debug";
}
exports.default = exports.logger;
