"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const logger_1 = __importDefault(require("../../shared/logger"));
const fs = require('fs');
const path = require('path');
let manifests = [];
// Método que retorna los archivos en el directorio actual
exports.getFilesInCurrentDirectory = (srcpath) => {
    return fs.readdirSync(srcpath).map((file) => path.join(srcpath, file));
};
// Método que retorna un array con los directorios encontrados
exports.getDirectories = (srcpath) => {
    return fs
        .readdirSync(srcpath)
        .map((file) => path.join(srcpath, file))
        .filter((path) => fs.statSync(path).isDirectory());
};
// Método que permite traer el contenido de todos los directorios indicados
exports.getManifestsContent = (files) => __awaiter(void 0, void 0, void 0, function* () {
    yield files.forEach((file) => __awaiter(void 0, void 0, void 0, function* () {
        yield exports.getInformation(path_1.resolve(file));
    }));
    return manifests;
});
// Método que permite traer el contenido de un solo directorio
exports.getManifestContent = (directory) => __awaiter(void 0, void 0, void 0, function* () {
    yield exports.getInformation(path_1.resolve(directory));
    return manifests[0];
});
// Metodo que trae el contenido de un directorio indicado
exports.getInformation = (dir) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        if (fs.existsSync(`${dir}/manifest.json`)) {
            // Do something
            let result = yield JSON.parse(fs.readFileSync(`${dir}/manifest.json`, 'utf8'));
            if (result) {
                result.path = dir;
                manifests.push(result);
            }
        }
        else {
            logger_1.default.debug(`manifest.json not found in ${dir}`);
        }
    }
    catch (error) {
        logger_1.default.debug(`error on read the manifest file in ${dir} check the content`);
    }
});
