"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const logger_1 = __importDefault(require("../logger"));
const chalk_1 = __importDefault(require("chalk"));
const get_content_files_1 = require("./get-content-files");
const choose_folders_1 = require("./choose-folders");
var path = require("path");
exports.readDirectoryByExtension = (directory, criterial, message, action) => __awaiter(void 0, void 0, void 0, function* () {
    logger_1.default.debug("Read current directory to find the indicate extensions files");
    // find directory in the current folder
    let currentDirectory = yield get_content_files_1.getFilesInCurrentDirectory(directory);
    // filter the directory to find the criterial folders
    let filter = currentDirectory.filter((item) => {
        let isFound = false;
        criterial.map((crit) => {
            if (path.extname(item) == crit) {
                isFound = true;
            }
        });
        return isFound;
    });
    // print log info
    logger_1.default.info(filter.length > 0
        ? `find ${chalk_1.default.redBright(`${filter.length}`)} files with the extension`
        : `files with the indicate extension not found in the current directory`);
    if (filter.length) {
        let choose = yield choose_folders_1.chooseFolders(filter, message, action);
        logger_1.default.info(`Total of files to use: ${chalk_1.default.whiteBright(`${choose.folders.length}`)}`);
        return choose.folders;
    }
    return [];
});
