"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const logger_1 = __importDefault(require("./../logger"));
const child_process_1 = require("child_process");
exports.runOnlyCommand = (command) => {
    const task = child_process_1.spawn(`${command}`, [], {
        shell: true
    });
    return new Promise(function (resolve) {
        // Método para imprimir el log normal
        task.stdout.on("data", (data) => {
            logger_1.default.debug(data.toString());
            resolve(data.toString());
        });
        // Método para imprimir el log de error
        task.stderr.on("data", function (data) {
            logger_1.default.debug("Error running the command: " + command);
            logger_1.default.error(data.toString());
            process.exit(1);
        });
    });
};
