"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("../../index");
const { spawn } = require("child_process");
exports.runCommand = function (options) {
    return new Promise(function (fulfill, reject) {
        index_1.logger.info(`Using component in the folder: ${options.path}`);
        const task = spawn(`cd ${options.path} && ${options.command}`, [], {
            shell: true
        });
        // Método para imprimir el log normal
        task.stdout.on("data", (data) => {
            index_1.logger.info(data.toString());
            if (exports.validateLog(options.command, data.toString(), "success")) {
                task.kill("SIGINT");
                fulfill(true);
            }
            if (exports.validateLog(options.command, data.toString(), "error")) {
                task.kill("SIGINT");
                fulfill(false);
                index_1.logger.error("Process error");
                process.exit(1);
            }
        });
        // Método para imprimir el log de error
        task.stderr.on("data", function (data) {
            index_1.logger.info(data.toString());
            // Validación en caso de error
            if (exports.validateLog(options.command, data.toString(), "error")) {
                task.kill("SIGINT");
                reject(false);
                index_1.logger.error("Process error");
                process.exit(1);
            }
            if (exports.validateLog(options.command, data.toString(), "success")) {
                task.kill("SIGINT");
                fulfill(true);
            }
        });
    });
};
/**
 * Método para validar que tipo de mensaje se esta retornando
 * command: string
 * type: string
 */
exports.validateLog = (command, logMessage, type) => {
    if (command == index_1.configuration.link) {
        if (type == "success") {
            const isFind = !!index_1.linkSuccessLog.find((element) => logMessage.includes(element.log));
            return isFind;
        }
        else if (type == "error") {
            const isFind = !!index_1.linkErrorLog.find((element) => logMessage.includes(element.log));
            return isFind;
        }
    }
    else if (command == index_1.configuration.publish) {
        if (type == "success") {
            const isFind = !!index_1.publishSuccessLog.find((element) => logMessage.includes(element.log));
            return isFind;
        }
        else if (type == "error") {
            const isFind = !!index_1.publishErrorLog.find((element) => logMessage.includes(element.log));
            return isFind;
        }
    }
};
