"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const shared_1 = require("../../../shared");
// variable que posee la lista de dependencias ordenadas por nivel
let dependenciesList = [];
// variable que posee la información  de los manifest.json
let manifests = [];
// 3. Método que permite obtener el orden de dependencias, arma un array donde se indica el grado de importancia por medio de un nivel
exports.getListProjects = (manifest) => __awaiter(void 0, void 0, void 0, function* () {
    manifests = manifest;
    // 1. Armo un array con dependencias de todos los componentes de la carpeta indicada. se inicia a nvl 0 ya que no hay dependencias validadas aun
    yield manifests.forEach((item) => {
        let obj = {
            level: 0,
            title: `${item.vendor}.${item.name}`,
            value: `${item.vendor}.${item.name}`,
            selected: true
        };
        dependenciesList.push(obj);
    });
    // 2. Recorro todas las dependencias de cada uno de los proyectos y valido sus dependencias, armando así el orden para importar los componentes
    yield manifests.forEach((_item, index) => {
        exports.resolverDependencies(manifests[index].dependencies, `${_item.vendor}.${_item.name}`);
    });
    return dependenciesList;
});
// Método para armar la estructura de nivel para las dependencias,
// Indica desde el nivel mas bajo hasta el mas alto el orden en que se van a compilar los componentes.
exports.findLevelDependency = function (item) {
    let obj = {
        level: 0,
        title: item,
        value: item,
        selected: true
    };
    let found = dependenciesList.find((res) => {
        if (res.value == item) {
            res.level += 1;
            return true;
        }
        else
            return false;
    });
    if (!found) {
        dependenciesList.push(obj);
    }
    dependenciesList = dependenciesList.sort((a, b) => a.level - b.level);
};
// Metodo que valida si ya hay dependencias de un componente y categoriza su nivel de dependencia (Función recursiva que valida en todas las dependencias si hay alguna que necesite de alguien más
exports.resolverDependencies = (dependencies, app_name) => __awaiter(void 0, void 0, void 0, function* () {
    for (const prop in dependencies) {
        let manifest = manifests.find(res => {
            if (`${res.vendor}.${res.name}` == prop &&
                `${res.vendor}.${res.name}` !== app_name) {
                shared_1.logger.debug(`dependencies found: ${prop}`);
                exports.findLevelDependency(prop);
                return true;
            }
            else {
                // log.debug(`dependencie not found: ${prop}`);
                return false;
            }
        });
        if (manifest) {
            exports.resolverDependencies(manifest.dependencies, app_name);
        }
    }
});
